﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace howto_use_filesystemwatcher
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Create the From and To directories.
        private void Form1_Load(object sender, EventArgs e)
        {
            Directory.CreateDirectory(txtInputDir.Text);
            Directory.CreateDirectory(txtOutputDir.Text);
        }

        // The input and output directories.
        private string InputDir, OutputDir;

        // Start the FileSystemWatcher.
        private void btnWatch_Click(object sender, EventArgs e)
        {
            // Clear the list of files moved.
            lstFilesMoved.Items.Clear();
            lstFilesMoved.Items.Add("Ready");

            // Make sure the file paths end with \.
            InputDir = txtInputDir.Text;
            if (!InputDir.EndsWith("\\")) InputDir += "\\";
            OutputDir = txtOutputDir.Text;
            if (!OutputDir.EndsWith("\\")) OutputDir += "\\";

            // Prepare and start the watcher.
            fswInputDir.Path = txtInputDir.Text;
            fswInputDir.EnableRaisingEvents = true;
        }

        // The watcher detected a new file. Move it into the output directory.
        private void fswInputDir_Created(object sender, FileSystemEventArgs e)
        {
            // Try to move the file.
            lstFilesMoved.Items.Add(e.Name);
            try
            {
                // Compose the source and destination file names.
                string from_file = InputDir + e.Name;
                string to_file = OutputDir + e.Name;

                // If the destination file already exists, delete it.
                if (File.Exists(to_file)) File.Delete(to_file);

                // Move the file.
                File.Move(from_file, to_file);
            }
            catch (Exception ex)
            {
                lstFilesMoved.Items.Add("    " + ex.Message);
            }
        }
    }
}
